;*********************************************************
;*	Grafik-Routinen fuer 256*256 pixel               *
;*	Alpha-Routinen fuer 32*24 zeichen                *
;*********************************************************

; Parameteruebergabe
; C: Zeichen oder Steuercode
; H: y zielkoordinate
; L: x zielkoordinate
; D: y
; E: x
; F: Z-Flag (POINT)

conout:
	push 	de 		;register retten
	push 	bc
	ld 	(akku),a
	push 	ix
	push 	hl		;wegen grafikbefehle
coinit:	db 	0c3h 		;jp vor init, ld hl,... nach init
cursor: dw 	coini 		;nach init cursoradresse
curs1: 	ld 	(hl),0 		;cursor loeschen
	ld 	a,c 		;zeichen
	ld 	hl,escseq
	bit 	0,(hl) 		;lauft esc-sequenz?
	jr 	nz,con1 	;ja
	cp 	esc 		;
	jp 	nz,con2 	;normales zeichen
	set 	0,(hl) 		;esc-flag
	res 	1,(hl) 		;rc-flag
	jr 	coret

con1: 	bit 	7,a 		;grafikbefehl?
	jr 	z,con12 	;ja
	bit 	1,(hl) 		;r?
	set 	1,(hl)
	res 	7,a
	jr 	z,con10 	;row
	res 	0,(hl)
	ld 	b,0
	res 	7,c 		;col
	ld 	hl,(curxy)
	add 	hl,bc
	jr 	conret

con10: 	ld 	hl,0 		;adresse bildwiederholspeicher
	or 	a 		;spalte 0?
	jr 	z,conret
	ld 	b,a 		;multiplikationszaehler
	ld 	de,10*20h 	;abstand zwischen zwei zeilen
con100: add 	hl,de
	djnz 	con100
conret: ld 	(curxy),hl
	ld 	de,9*32 	;cursorzeile
	add 	hl,de 		;berechnen
curs2: 	ld 	(hl),11111000b 	;cursor
	ld 	(cursor),hl
coret: 	pop 	hl 		;register
	pop 	ix
	pop 	bc
	pop 	de
	ld 	a,(akku)
	ret
coret1:
	exx 			;register bei grafik
	ex 	af,af'
	pop 	af
	pop 	bc
	pop 	de
	pop 	hl
	exx
	ex 	af,af'
	jr 	coret

	;grafik-befehle
con12: 	res 	0,(hl) 		;esc-flag ruecksetzen
	pop 	hl
	push 	hl 		;register retten
	exx
	ex 	af,af'
	push 	hl
	push 	de
	push 	bc
	push 	af
	ld 	hl,coret1
	push 	hl
	exx
	push 	hl
	ld 	hl,contbl
	ld 	b,0
	sla 	c 		;*2
	add 	hl,bc 		;adresse der grafikroutine
	ld 	a,(hl)
	inc 	hl
	ld 	h,(hl)
	ld 	l,a
	ex 	(sp),hl 	;hl wieder koordinate
	ret
	
	;tabelle der grafikbefehle
contbl: dw 	clscreen 	;0
	dw 	clsw 		;1
	dw 	setpoint 	;2
	dw 	draw 		;3
	dw 	point 		;4
	dw 	penup 		;5
	dw 	pendn 		;6
	dw 	erase 		;7
	dw 	pen 		;8
	dw 	gpage 		;9
	dw 	reserve 	;10
	dw 	cursof 		;11
	dw 	curson 		;12
	dw 	reserve 	;13
	dw 	reserve 	;14
	dw 	reserve 	;15
	
reserve:
	ret 			;nicht benutzt, reserve dient der
				;erweiterung.

	;text ausgabe
con2: 	ld 	hl,conret
	push 	hl 		;ruecksprung (cursor an)
	and 	7fh
	cp 	' ' 		;alpha oder steuerzeichen?
	jr 	c,con3 		;steuerzeichen
	;zeichen auf bildschirm schreiben
char: 	ld 	l,a 		;zeichencode
	ld 	h,0
	rept 3 			;*8
	add 	hl,hl
	endm 
	ld 	de,chargen
	add 	hl,de 		;adresse im zeichengenerator
	ld 	ix,(curxy) 	;cursor
	push 	ix
	ld 	de,20h 		;offset zur naechsten zeile
	ld 	b,8
char1: 	ld 	a,(hl) 		;zeile im zeichen
	ld 	(ix),a 		;in den bildwiederholspeicher
	inc 	hl 		;naechste zeile im zeicheh
	add 	ix,de 		;naechste zeile auf dem bildschirm
	djnz	char1 		;weiter
	pop 	hl

	;cursor rechts
cocur: 	inc 	hl 		;naechste zeichenposition
	ld 	a,l 		;test ob noch in zeile
	and 	00011111b
	ret 	nz 		;keine neue zeile
	dec 	hl 		;zur korrektur
	call 	cocr 		;cr ausfuehren
	ld 	a,lf 		;anschliessend If
	ld 	(curxy),hl
con3: 	ld 	hl,(curxy)
	ld 	de,10*20h 	;abstand zwischen zwei zeilen
	cp 	cr
	jr 	z,cocr 		;carriage return
	cp 	lf
	jr 	z,colf 		;line feed
	cp 	bs
	jr 	z,cobs 		;bs
	cp 	cls
	jr 	z,clscreen 	;cis
	cp 	home 
	jr 	z,cohome 	;home
	cp 	curu
	jr 	z,cocuup 	;cursor hoch
	cp 	curr
	jr 	z,cocur 	; cursor rechts
	ret
	
	;carriage return
cocr: 	ld 	a,l 		;1. position herstellen
	and 	11100000b
	ld 	l,a
	ret
	
	;line feed
colf: 	add 	hl,de 		;naechste zeile
	ld 	a,h
	and 	00011111b 	;relative position
	cp 	24*10/8+1 	;im bildschirmbereich?
	ret 	c 		;ja
corol: 	sbc 	hl,de 		;wieder zurueckrechnen
	push 	hl
corol1: ld	hl,0 		;adresse des bildwiederholspeichers
	push 	hl
	add 	hl,de 		;1. zeile
	pop 	de
	ld 	bc,240*32 	;anzahl
	ldir
	ld 	h,d 		;nun letzte zeile loeschen
	ld 	l,e
	inc 	de
	ld 	bc,32*256-(240*32)
	ld 	(hl),0
	ldir
	pop 	hl 		;cursoradresse
	ret
	
	;backstep
cobs: 	ld 	a,l
	and 	00011111b
	dec 	hl
	ret 	nz 		;normaler bs
	inc 	hl
	ld 	a,l
	or 	00011111b 	;ans zeilenende
	ld 	l,a 		;anschliessend cursor hoch
	
	;cursor hoch
cocuup: or 	a
	sbc 	hl,de
	ld 	a,h
	and 	11100000b
cocup1: cp 	0		;ist cursor noch im bildschirm?
	ret 	nc 		;ja
	jr 	cohome
	
	;bildschirm loeschen
coini: 	ld 	bc,conret
	push 	bc
	call 	gpage
	ld 	a,21h 		;programm patchen
	ld 	(coinit),a
	
clscreen:
	xor 	a 		;dunkel loeschen
	db 	1
clsw: 	ld 	a,255 		;weiss loeschen
	ld 	b,a
	ld 	hl,(crtram)
	ld 	(hl),b 		;loeschen
	ld 	d,h
	ld 	e,l
	inc 	de
	ld 	bc,256/8*256 	;anzahl
	ldir
	
	;home
cohome: ld 	hl,(con10+1)
	ret
	
curson: ld 	hl,0036h 	;(ld (hl),0)
	ld 	(curs1),hl
	ld 	hl,0f836h 	;(ld (hl),111111000b)
	ld 	(curs2),hl
	ret
	
cursof: ld 	hl,0 		;programm so veraendern, dass
	ld 	(curs1),hl 	;alle cursor zeichnenden
	ld 	(curs2),hl 	;befehle durch nops ersetzt
	ret 			;werden.
	
gpage: 	ld 	a,h 		;hi-adresse des bildwiederhol-
	and 	11100000b 	;speichers
	ld 	h,a
	ld 	l,0
	ld 	(crtram),hl
	ld 	(curxy),hl 	;programm patchen
	ld 	(con10+1),hl
	ld 	(corol1+1),hl
	ld 	(setp3+1),a
	ld 	(cocup1+1),a
	ld 	a,d
	out 	(video),a
	ret
	
setpoint:
	ld 	a,l 		;x-adresse
				;adresse umrechnen
	rept 3 			;/8 weil 8 pixel pro zeichenfeld
	srl 	h
	rr 	l
	endm
	and 	111b 		;vorderen bits zu 0
	rept 3 			;*8 wegen code der bitbefehle
	rlca
	endm
setp1: 	or 	11000110b 	; op-code des bit-befehls
	ld 	(setp2+1),a
setp3: 	ld	a,80h 		;hi-teil der bildschirmadresse
	or 	h 		;tatsaechliche adresse bestimmen
	ld 	h,a
setp2: 	set 0,(hl)
	ret

draw: 	ex 	de,hl
	ld 	a,e 		;dx berechnen
	sub 	l 		;dx=xend-x0
	db 	06h 		;ld b,...
	inc 	l
	jr 	nc,draw2
	db	06h 		;ld b,...
	dec 	l
	neg 			;dx=-dx
draw2: 	push 	af
	ld 	a,b
	ld 	(xstep),a
draw3: 	ld 	a,d 		;dy berechnen
	sub 	h 		;dy=yend-y0
	db 	06h 		;ld b,...
	inc 	h
	ld 	c,-1 		;d=-1 (<0)
	jr 	z,draw4 	;wenn dy=0
	inc 	c		;id=0
	jp 	nc,draw4
	db 	06h		;ld b,...
	dec 	h
	neg 			;dy=-dy
draw4: 	push 	af
	ld 	a,b
	ld 	(ystep),a
	ld 	a,c 		;d
	add 	a,0
	exx
	ld 	h,a 		;hl=d setzen
	ld 	l,a
	ex 	af,af' 		;vorzeichen d
	pop 	af 		;dy
	ld 	e,a
	pop 	af 		;dx
	ld 	c,a
	ld 	d,0
	ld 	b,d
	ex 	af,af'
next: 	ex 	af,af'
	exx
	push 	hl
	call 	setpoint
	pop 	hl
	ld 	a,l
	cp 	e 		;x=xend?
	jp 	nz,noend 	;nein
	ld 	a,h
	cp 	d 		;iy=yend
	ret 	z 		;ja
noend: 	ex 	af,af' 		;vorzeichen d
	jp 	p,ystep 	;wenn d>=0
xstep: 	inc 	l		;bei dx>=0, sonst dec l
	exx
	or 	a
	adc 	hl,de 		;d=d+dy
	jp 	next
ystep: 	inc 	h 		;bei dy>=O, sonst dec h
	exx
	or 	a
	sbc 	hl,bc 		;d=d-dx
	jp 	next

point: 	ld 	a,(setp1+1) 	;curr code retten
	ld 	(point1+1),a
	ld 	a,01000110b 	;bit x,(hl)
	ld 	(setp1+1),a
	call 	setpoint 	;punkt testen
point1: ld 	a,0 		;und anschliessend schreibmodus
	db 	1 		;wieder herstellen
erase: 	ld 	a,10000110b 	;res x,(hl)
	db 	1
pen: 	ld 	a,11000110b 	;set x,(hl)
	ld 	(setp1+1),a
	ret

penup: 	ld 	a,0c9h 		;ret
	db 	1
pendn:	ld 	a,07dh 		;ld a,l
	ld 	(setpoint),a
	ret

