;******************************
;* MONITORPROGRAMM            *
;*                            *
;* V3.0 10/85                 *
;* ROM-TEIL                   *
;******************************
;Quellen: electronica 227, Mikroelektronik in der Amateurpraxis 4
;reassembliert und zusammengesetzt: V.Pohlers, 13.04.2012

	cpu	z80
h              function x,(x>>8)&255
l              function x, x&255


MONI: 	NOP
	NOP
	NOP
	NOP
	LD 	B,0
	DJNZ 	$

	LD 	HL,PGM
	LD 	DE,START
	LD 	BC,4096 		;4k
	LDIR
	JP 	START

PGM:

	PHASE 	0F000H


	;SPRUNGTABELLE:

START: 	JP 	BEGIN
CI: 	JP 	CIX 		;TASTATUR
RI: 	JP 	RIX 		;CASSETTE LESEN
CO: 	JP 	COX 		;BILDSCHIRM
POO: 	JP 	POX 		;CASSETTE SCHREIBEN
LO: 	JP 	LOX 		;DRUCKER
	JP 	CSTS 		;KONSOLSTATUS
	JP 	IOBYTE
	JP 	IOSET
MEMCK: 	JP 	MEMSI 		;SPEICHERBEREICH
RSTAR: 	JP 	MAIN 		;RESTART MONITOR

BEGIN: 	LD 	SP,STACK
	OUT 	(ROMOF),A
	LD 	C,IOBYT
	CALL 	IOSET
	LD 	HL,CRTBG-1
	LD 	(MSIZE),HL
	INC 	HL 		;BILDSCHIRM INITIALISIEREN
	LD 	D,H
	LD 	E,L
	CALL	CO
	CALL 	PRINT 		;MELDUNG AUSGEBEN
	DB CLS," H.MON V3.0 10/85",CR,LF,0
	CALL 	CINIT 		;CASSETTE INITIALISIEREN
	JR 	MAIN


;******************************
;* MAIN                       *
;******************************

ERROR:	CALL	PRINT
	DB	"ILLEGAL COMMAND"
	DB	0

;BEFEHLSZEILE EINGEBEN UND PROGRAMM ANSPRINGEN

MAIN:	LD	SP,STACK		;NEU LADEN
	ld	c, ESC
	call	CO
	ld	c, 0Ch			;cursor on
	call	CO
	CALL	INL			;EINGABE BEFEHLSZEILE
	CALL	FNEXT			;SPACE AUSBLENDEN
	JR	C, MAIN			;NUR BEI CR
	LD	(TXTPT),DE
	LD	HL,START		;SUCHBEGINN
	LD	BC,0FFFFH		;64K DURCHSUCHEN
MAIN1:	LD	A,L(HEAD)
	CPIR				;NACH ED SUCHEN
	JR	NZ, ERROR		;FEHLER
	LD	A,H(HEAD)		;FOLGT FF?
	CP	A, (HL)
	JR	NZ, MAIN1		;NEIN
	LD	DE,(TXTPT)
MAIN2:	LD	A,(DE)			;VERGLEICHEN
	INC	HL
	INC	DE
	DEC	BC
	CP	A, (HL)
	JR	Z, MAIN2		;GLEICH
	CP	A, ' '			;TEST TRENNZEICHEN/CR
	JR	Z, MAIN3
	CP	','

	JR	Z, MAIN3
	CP	A, CR
	JR	NZ, MAIN1		;WEITERSUCHEN
;EVT.DOCH KEIN BEFEHL?
MAIN3:	XOR	A			;TEST RAHMEN
	DEC	HL
	PUSH	BC
	LD	BC,8
	CPIR
	POP	BC
	JR	NZ, MAIN1
;HL ZEIGT JETZT AUF 1.BEFEHL
;DE ZEIGT JETZT AUF 1.ARGUMENT
	LD	BC,MAIN			;RUECKSPRUNG
	PUSH	BC
	JP	(HL)			;SPRUNG ZUM PROGRAMM


;EINZELNE ARGUMENTE HOLEN

GFINA:	CALL	FNEXT			;FILENAME
	LD	HL,FINA
	LD	B,8
GFIN1:	CALL	FNEXT
	JR	Z, GFIN2		;WEIL TRENNZEICHEN
	LD	(HL),A
	INC	HL
	INC	DE
	DJNZ	GFIN1
GFIN3:	CALL	FNEXT			;UEBERFLUESSIGE ZEICHEN IGNORIEREN

	RET	Z
	INC	DE
	JR	GFIN3
GFIN2:	LD	(HL),' '		;MIT SPACE AUFFUELLEN
	INC	HL
	DJNZ	GFIN2
NICHT:	RET

GFITY:	CALL	FNEXT			;FILETYP/OPTION
	LD	HL,FITY
	LD	B,2
	CP	A, '@'
	JR	NZ, GFIN2
	INC	DE
	JR	GFIN1

GCOM:	CALL	FNEXT			;ZUSAETZL.ANGABEN
	LD	HL,DATA
	LD	B,16
	CP	A, ';'
	JR	NZ, GFIN2
GCOM1:	INC	DE
	LD	A,(DE)
	CP	A, CR
	JR	Z, GFIN2
	LD	(HL),A
	INC	HL
	DJNZ	GCOM1
	RET


;ASCII -> HEX

INHEX:	LD	A,' '			;HEX VON TASTATUR HOLEN
	CALL	COO
	CALL	INL00

ASHEX:	CALL	FNEXT			;KONVERTIEREN
	CALL	CNVBN
	LD	A,(DE)
	RET	C			;KEIN HEX
	PUSH	BC
	LD	HL,0
ASH1:	LD	A,(DE)
	CALL	CNVBN
	JR	C, ASH4
ASH3:	ADD	HL,HL			;SCHIEBEN
	ADD	HL,HL
	ADD	HL,HL
	ADD	HL,HL
	LD	B,0
	LD	C,A
	ADD	HL,BC
	INC	DE
	JR	ASH1
ASH4:	POP	BC
	XOR	A
	RET

CNVBN:	SUB	30H
	RET	C

	CP	A, 10
	CCF
	RET	NC
	CP	A, 11H
	RET	C
	CP	A, 17H
	CCF
	RET	C
	SUB	7
	RET


;OUTHEX
;WANDELT HEX=>ASCII
;OUTH GIBT BYTE <A> AUS

OUTH:	PUSH	AF
	RRA				;SCHIEBEN
	RRA
	RRA
	RRA
	CALL	OUTH1
	POP	AF
OUTH1:	PUSH	AF
	AND	A, 00001111B
	ADD	A, 030H
	CP	A, 03AH
	JR	C, OUTH2
	ADD	A, 07
OUTH2:	CALL	COO

	POP	AF
	RET

;OUTHL GIBT WORT <HL> AUS

OUTHL:	PUSH	AF
	LD	A,H
	CALL	OUTH
	LD	A,L
	CALL	OUTH
	POP	AF
	RET

FNEXT:	LD	A,(DE)
	CP	A, ' '
	JR	NZ, FNEX3
FNEX1:	INC	DE
	LD	A,(DE)
	CP	A, ' '
	JR	Z, FNEX1		;SPACE AUSBLENDEN
	CP	CR
	JR	Z, FNEX4
FNEX2:	XOR	A
	LD	A,(DE)
	RET
FNEX3:	CP	A, CR
FNEX4:	SCF
	RET	Z
	CCF
	CP	','

	INC	DE
	JR	Z, FNEX2
	OR	A
	DEC	DE
	RET

;PRINT GIBT ZEICHENKETTE BIS 0 AUS

PRINT:	EX	(SP),HL
PR1:	LD	A,(HL)
	INC	HL
	OR	A			;PRINT-ENDE?
	JR	Z, PR2			;JA
	CALL	COO
	JR	PR1
PR2:	EX	(SP),HL
	RET

;BEFEHLSZEILEN-EINGABE

INL:	CALL	PRINT
        db 	CR,LF
	db 	'&'			;PROMT
	DB	0
INL00:	LD	DE,TXTBU
	LD	B,BULEN
INL1:	CALL	CI
	CP	A, ERA			;ZEILE LOESCHEN
	JR	Z, INL
	CP	A, CURL			;BACKSTEP
	JR	Z, INL3
	CP	A, CR			;RETURN TASTE?
	JR	Z, INL2
	CP	A, 20H
	JR	C, INL1			;NICHT DARSTELLBARES ZEICHEN
	CALL	COO
	LD	(DE),A
	INC	DE
	DJNZ	INL1			;WEITER
INL3:	LD	A,B			;BACKSTEP
	CP	A, BULEN
	JR	Z, INL1
	DEC	DE
	INC	B
	CALL	PRINT
	DB	CURL
	DB	" "
	DB	CURL
	DB	0
	JR	INL1
INL2:	LD	(DE),A			;CR
	LD	DE,TXTBU		;ADR. TEXTPUFFER


CRALF:	ld      a, 0Dh
	call    COO
	ld      a, 0Ah
	jp      COO


;******************************
;* MEMORY                     *
;******************************

 	DW	HEAD
	DB	"MEMORY"
	DB	0
        call    ASHEX
MEMO1:  jr      c, MEM
        ld      (ARG1), hl
MEM:    cp      'Q'
        ret     z
        ld      a, CLS		;BILDSCHIRM LOESCHEN
        call    COO
        ld      a, CURD
        call    COO
;AUSGABE
        ld      b, 8
        ld      c, ' '
        xor     a
loc_F1ED:
	call    OUTH
        inc     a
        push    af
        call    CO
        pop     af
        djnz    loc_F1ED
        call    PRINT
	db "01234567",0
        ld      b, MEML
        ld      a, '-'
loc_F208:
	call    COO
        djnz    loc_F208
        ld      b, 8
        ld      a, 8
        call    COO
        ld      a, ' '
        call    COO
        ld      a, '-'
loc_F21B:
	call    COO
        djnz    loc_F21B
        call    CRALF
        ld      a, 'H'
        ld      (asc_F38C+1), a
        ld      hl, (ARG1)
        ld      (ARG2), hl
MEM2:   ld      hl, (ARG2)
        ld      a, l		;MODULO RECHNEN
        and     -MEMB
        ld      l, a
        ld      (ARG2), hl	;ADR 1.BYTE
        ex      de, hl		;DE=BEGINN
        call    PRINT
        db 	1,LF,LF,LF,0
        ld      b, 10h
MEM3:   push    bc		;RETTEN
        push    de		;BEG.
        ld      b, 8
MEM4:   ld      a, (de)
        inc     de
        call    OUTH
        ld      a, ' '
        call    COO
        djnz    MEM4
        ld      b, 8
        pop     de
loc_F256:
	ld      a, (de)
        inc     de
        and     7Fh
        cp      ' '
        jr      nc, loc_F260
        ld      a, '.'
loc_F260:
	call    COO
        djnz    loc_F256
        pop     bc
        djnz    MEM3

loc_F268:
	call    loc_F389
        call    sub_F34C
        ld      a, (asc_F38C+1)
        ld      h, a
        cp      'Q'
        jr      nz, loc_F283
        call    PRINT
    	db 1Bh,93h,81h,0
        call    INHEX
        jp      MEMO1

;EINGABE
loc_F283:
	ld      e, h		;MODE FUER SPAETER
        ld      d, 2		;TETRADEN BYTEEINGABE
MEM8:   call    CI		;ZEICHEN VON TASTATUR HOLEN
        cp      ESC		;UMSCHALTUNG HEX<==>ASCII EINGABE
        jr      nz, MEM10
        ld      a, 'H'
        cp      e		;VERGLEICH MIT MODE
        jr      nz, MEM9	;H ==>MODE
        ld      a, 'A'
MEM9:   ld      (asc_F38C+1), a
        jp      loc_F268

MEM10:  ld      bc, -MEMB	;INC FUER CURSOR
        cp      CURU		;HOCH
        jr      z, MEM15
        ld      c, -1		;BC=-1
        cp      CURL		;LINKS
        jr      z, MEM15
        inc     bc
        inc     bc		;BC=
        cp      CURR		;RECHTS
        jr      z, MEM15
        ld      c, MEMB
        cp      CURD		;RUNTER
        jr      z, MEM15
        cp      'Q'
        jr      z, MEM9		;QUIT?
        cp      ' '
        call    nc, COO
;RAM BESCHREIBEN
        ld      l, a		;ZEICHEN RETTEN
        ld      a, e		;MODE
        cp      'A'		;ASCII EINGABE?
        ld      a, l
        jr      z, MEM14	;JA
; HEX EINGABE
        call    CNVBN
        push    af
        call    c, sub_F34C
        pop     af
        jr      c, loc_F268	;KEIN HEX,NEUE EINGABE
        ld      hl, ARG3	;HILFSZELLEN
        rld
        dec     d		;TETRADENZAEHLER
        jr      nz, MEM8	;NAECHSTES ZEICHEN
        ld      a, (ARG3)	;NEUES BYTE
MEM14:  ld      hl, (ARG1)	;CURSOR
        ld      (hl), a		;=>RAM
        cp      (hl)		;ANGEKOMMEN?
        ld      a, (asc_F38C+1)
        push    af
        ld      a, 'H'
        ld      (asc_F38C+1), a
        call    sub_F34C
        ld      a, (hl)
        call    OUTH
        ld      a, 'A'
        ld      (asc_F38C+1), a
        call    sub_F34C
        ld      a, (hl)
        and     7Fh
        cp      ' '
        jr      nc, loc_F2FE
        ld      a, '.'
loc_F2FE:
	call    COO
        pop     af
        ld      (asc_F38C+1), a
        jr      nz, MEM19	;NEIN,RAM FEHLER
        ld      bc, 1		;ADR INC
MEM15:  ld      hl, (ARG2)
        ld      de, 80h
        add     hl, de
        ex      de, hl
        ld      hl, (ARG1)	;CURSOR
        add     hl, bc		;CURSOR+INC
        ld      (ARG1), hl	;NEUER CURSOR
        bit     7, b		;CURSOR RICHTUNG
        jr      z, MEM16	;ADDITION
        ex      de, hl		;DE=CURSOR
        ld      hl, (ARG2)	;ANFANG
        inc     de
MEM16:  or      a
        sbc     hl, de		;ANF-CURS,CURS-ENDE
        jr      z, MEM17
        jp      m, loc_F268
MEM17:  dec     c			;C=1?
        jr      nz, MEM18
        ld      c, 7
MEM18:  inc     c
        ld      hl, (ARG2)	;NEUEN ANFANG BERECHNEN
        add     hl, bc
        ld      (ARG2), hl
        jp      MEM2

MEM19:  call    PRINT
        db 	CLS,"RAM ERROR "
        db    	0
        jp      MEM2
;
sub_F34C:
	exx
        ld      hl, (ARG1)
        ld      bc, (ARG2)
        or      a
        sbc     hl, bc
        ld      a, 1Bh
        call    COO
        ld      a, l
        or      a
        rra
        rra
        scf
        rra
        add     a, 3
        and     9Fh ; ''
        call    COO
        ld      a, l
        and     7
        ld      b, a
        ld      a, (asc_F38C+1)
        cp      'A'
        jr      z, loc_F384
        xor     a
        dec     b
        inc     b
        jr      z, loc_F37D
loc_F379:
	add     a, 3
        djnz    loc_F379
loc_F37D:
	or      80h
        call    COO
        exx
        ret
;
loc_F384:
	ld      a, 18h
        add     a, b
loc_F387:
	jr      loc_F37D
;
loc_F389:
	call    PRINT
asc_F38C:
	db 	1,"H  CURSOR:",0
        ld      hl, (ARG1)
        jp      OUTHL


;******************************
;* MOVE                       *
;******************************

	DW	HEAD

	DB	"MOVE"
	NOP
	CALL	ASHEX
	JP	C, ERROR
	LD	(ARG1),HL
	CALL	ASHEX
	JP	C, ERROR
	LD	(ARG2),HL
	CALL	ASHEX
	JP	C, ERROR
	LD	B,H
	LD	C,L
	LD	HL,(ARG1)
	LD	DE,(ARG2)
MOVE:	PUSH	HL
	XOR	A
	EX	DE,HL
	SBC	HL,DE			;ENDE-ANF=ANZAHL
	INC	HL
	LD	D,B
	LD	E,C			;DE=ZIEL
	LD	B,H
	LD	C,L			;BC=LAENGE
	POP	HL			;HL=QUELLE
	PUSH	HL
	OR	A			;CY=0
	SBC	HL,DE			;MOVE-RICHTUNG
	POP	HL
	JR	C, MOVE1
	LDIR				;VORWAERTS UMLADEN
	ret
MOVE1:	DEC	BC
	ADD	HL,BC
	EX	DE,HL
	ADD	HL,BC
	EX	DE,HL
	INC	BC
	LDDR
	ret


;******************************
;* LOAD                       *
;******************************

;D7=1.LESEN,D6=UEBERLESEN
;D5=BLOCK WAR FALSCH,D4=ALLES KORRIGIERT

	DW	HEAD
	DB	"LOAD"
	NOP
LDEXT:	CALL	GFINA
	CALL	GFITY
	CALL	ASHEX
	JR	NC, LOAD
	LD	HL,0			;KEIN OFFSET
LOAD:	PUSH	HL
	POP	IY

	CALL	CINIT
	LD	HL,(FITY)		;OPTION
	LD	E,0			;E=FEHLER,D=KORREKTURZAHLER
	EXX
LOD0:	LD	D,80H			;1.LESEN
LOD1:	BIT	7,D
	JP	Z, LOD12		;FILE NICHT LESBAR
	EXX
	LD	D,0
	EXX
LOD2:	CALL	LOD14			;SYNCHRONISIEREN
	CP	A, NL
	JR	NZ, LOD3
	CALL	RIX
LOD3:	CP	A, SOH
	JR	NZ, LOD2		;KEIN SOH
	XOR	A
	LD	C,A			;PRUEFSUMME=0
	LD	E,A			;BLOCKZAHLER
	LD	HL,FINA
	LD	B,8
LOD4:	CALL	RIX			;FILENAME VERGLEICHEN
	CP	A, (HL)
	JR	NZ, LOD1		;NICHT GLEICH
	INC	HL
	ADD	A, C
	LD	C,A
	DJNZ	LOD4
	LD	B,24			;KOPF LADEN
	BIT	7,D			;1.LESEN

	JR	NZ, LOD5		;JA
	SET	6,D			;2.LESEN,KOPF UEBERLESEN
LOD5:	CALL	LOD16			;BLOCK LESEN
	JR	Z, LOD51		;KOPF RICHTIG
	BIT	7,D
	JR	NZ, LOD0
LOD51:	BIT	7,D
	JR	Z, LOD6			;2.LESEN
	CALL	PRINT
	db 	CR,LF
	DB	"FILE FOUND "
	DB	0
	PUSH	IY
	POP	BC			;OFFSET
	LD	HL,(ARG1)
	ADD	HL,BC
	LD	(ARG1),HL
	LD	HL,(ARG2)
	ADD	HL,BC
	LD	(ARG2),HL
	LD	A,B
	OR	C
	JR	Z, LOD6			;OFFSET=O
	XOR	A
	LD	(FITY),A		;AUTOSTART UNTERDRUECKEN
;DATENBLOECKE LESEN
LOD6:	LD	IX,DATA
	LD	HL,(ARG1)		;ANFANGSADR
LOD7:	CALL	LOD14
	CP	A, EOT

	JP	Z, LOD12
	CP	A, ETX			;ENDE?
	JR	Z, LOD10		;JA
	CP	A, GS
	JR	NZ, LOD7		;KEIN RICHTIGER BLOCKANFANG
	LD	C,0
	CALL	RIX			;BLOCKLAENGE
	LD	B,A
	LD	C,A
	RES	5,D
	BIT	7,D
	JR	NZ, LOD8		;1.LESEN
	SET	6,D			;FUER UBERLESEN,2.LESEN
	BIT	4,D
	JR	NZ, LOD8		;ALLES KORR.
	PUSH	DE
	LD	A,D
	AND	A, 0FH
	LD	D,(IX+1)
;WAR BLOCK SCHON FALSCH
	CP	A, D
	POP	DE
	JR	NZ, LOD8		;NEIN
	LD	A,(IX)
	CP	A, E
	JR	NZ, LOD8		;NEIN
	INC	IX
	INC	IX
	EXX
	DEC	D			;KORREKTURZAEHLER-1
	EXX
	JR	NZ, LOD71		;ALLES KORRIGIERT?
	SET	4,D			;KEINE FALSCHEN BLOECKE MEHR
LOD71:	RES	6,D			;FREIGABE RAM SCHREIBEN
	SET	5,D			;KORREKTURFLAG
LOD8:	CALL	LOD16			;BLOCK LESEN
	JR	Z, LOD9			;PRUEFSUMME OK
	BIT	5,D			;WURDE BLOCK EBEN KORRIGIERT?
	JR	NZ, LOD12		;JA,FILE NICHT LESBAR
	BIT	7,D			;NEIN
	JR	Z, LOD9			;FEHLER IGNORIEREN
	EXX
	INC	D
	LD	A,D
	EXX				;KORREKTURZAEHLER+1
	CP	A, 8
	JP	Z, LOD0			;ZU VIELE FEHLER,NOCHMAL VERSUCHEN
	LD	(IX+1),D		;BLOCKNR. ABLEGEN
	RES	7,(IX+1)		;FLAG LOESCHEN
	LD	(IX+0),E
	INC	IX			;ERRORPOINTER
	INC	IX
LOD9:	INC	DE			;BLOCKZAEHLER+1
	JR	LOD7
;ETX BEHANDLUNG
LOD10:	LD	A,D
	AND	A, 80H			;ZAHLER LOESCHEN,1/2-FLAG NICHT
	LD	D,A
	DEC	HL			;ENDADR.-1
	LD	BC,(ARG2)
	SBC	HL,BC			;STIMMT ENDADR.?
	JP	NZ, LOD1		;NEIN
	EXX
	LD	A,D
	OR	A			;TRATEN FEHLER AUF?
	JR	Z, LOD11		;NEIN
	EXX
	LD	D,L			;2.LESEN
	JP	LOD2
LOD11:	CALL	LOD13			;FEHLERAUSGABE
	LD	A,(FITY)
	CP	A, 'P'
	RET	NZ
	LD	A,L
	CP	A, 'Q'
	RET	Z
	LD	HL,(ARG3)
	JP	(HL)			;AUTOSTART
LOD12:	EXX
	CALL	PRINT
	DB	" BAD FILE "
	DB	0
LOD13:	LD	A,E
	OR	A
	RET	Z
	CALL	OUTH
	CALL	PRINT
	DB	" ERRORS"
	DB	0
	RET

;SYNCHRONISIEREN
LOD14:	CALL	RIX
	INC	A
	JR	NZ, LOD14
LOD15:	CALL	RIX
	CP	A, 0FFH
	JR	Z, LOD15
	RET
;BLOCK LESEN
LOD16:	CALL	RIX
	BIT	6,D
	JR	NZ, LOD17		;UEBERLESEN
	LD	(HL),A
LOD17:	ADD	A, C
	LD	C,A
	INC	HL
	DJNZ	LOD16
	CALL	RIX			;PRUEFSUMME
	ADD	A, C
	RES	6,D			;PRUEFSUMME OK
	RET	Z
	EXX
	INC	E
	EXX				;FEHLERZAHLER+1
	RET

;******************************
;* SAVE                       *
;******************************

	DW	HEAD
	DB	"SAVE"
	NOP
SAEXT:	CALL	GFINA			;FILENAME HOLEN
	CALL	GFITY			;FILETYP
	CALL	ASHEX			;STARTADRESSE
	JP	C, ERROR
	LD	(ARG1),HL
	CALL	ASHEX			;ENDADRESSE
	JP	C, ERROR
	LD	(ARG2),HL
	CALL	ASHEX			;EINTRITTSPUNKT
	JR	NC, SAVE
	LD	HL,RSTAR		;FEHLT,DESHALB RSTAR
SAVE:	LD	(ARG3),HL
	CALL	GCOM
	CALL	CINIT
	LD	HL,SAVEE
	PUSH	HL
	LD	HL,SAVE0
	PUSH	HL			;RETURN=>SAVE0
	PUSH	HL
	LD	C,NL			;FILEANFANG
	LD	A,(FITY)
	CP	A, ' '
	JR	NZ, SAVE0
	LD	A,'P'			;KEINE ANGABE
	LD	(FITY),A
SAVE0:	LD	B,20
SAVE1:	LD	A,0FFH			;SYNCHRCNZEICHEN
	CALL	CPO
	DJNZ	SAVE1
	LD	A,C
	CALL	CPO			;NL ODER SYNCHRONZEICHEN
	LD	A,SOH			;START KOPF
	CALL	CPO
;KOPF AUSGEBEN
;SOH/FILENAME/TT/AA/EE/SS/................/PS/STX
	LD	HL,FINA
	LD	B,32
	LD	C,0
SAVE2:	LD	A,(HL)
	CALL	CPO
	LD	A,(HL)
	ADD	A, C			;PRUEFSUMME
	LD	C,A
	INC	HL
	DJNZ	SAVE2
	NEG
	CALL	CPO			;PUEFSUMME
	LD	A,STX			;KOPF-ENDE
	CALL	CPO
	LD	DE,(ARG1)		;ANF.ADR.
SAVE3:	LD	B,6
SAVE4:	LD	A,0FFH			;SYNC.
	CALL	CPO
	DJNZ	SAVE4
	LD	HL,(ARG2)		;ENDADR.
	INC	HL
	SBC	HL,DE			;BLOCKLAENGE BERECHNEN

	JR	Z, SAVE8		;FERTIG
	XOR	A
	OR	H
	JR	NZ, SAVE5
	ADD	A, L
	JP	P, SAVE6
SAVE5:	LD	L,80H
SAVE6:	LD	B,L			;BYTEZAEHLER
	LD	A,GS			;START BLOCK
	CALL	CPO
	LD	A,B
	LD	C,A
	CALL	CPO			;BLOCKLAENGE
SAVE7:	LD	A,(DE)
	CALL	CPO
	LD	A,(DE)
	INC	DE
	ADD	A, C
	LD	C,A
	DJNZ	SAVE7
	NEG
	CALL	CPO			;PRUEFSUMME
	JR	SAVE3
SAVE8:	LD	A,ETX
	LD	C,0FFH			;2.AUFZEICHNUNG
	JP	CPO
SAVEE:	LD	B,32
SAVEF:	LD	A,0FFH
	CALL	CPO
	DJNZ	SAVEF
	LD	A,EOT
	JP	CPO


;******************************
;* IN OUT                     *
;******************************

	DW	HEAD
	DB	"IN"
	NOP
	CALL	ASHEX
	LD	C,L
	IN	A, (C)
	JP	OUTH

	DW	HEAD
	DB	"OUT"
	NOP
	CALL	ASHEX			;PORTADRESSE HOLEN
	LD	C,L
	CALL	ASHEX			;WERT HOLEN
	OUT	(C), L
	RET

;******************************
;* FILL                       *
;******************************

	DW	HEAD
	DB	"FILL"
	NOP
	CALL	ASHEX
	JP	C, ERROR
	LD	(ARG1),HL
	CALL	ASHEX
	JP	C, ERROR
	LD	(ARG2),HL
	CALL	ASHEX
	LD	C,L			;FUELLBYTE
	LD	HL,(ARG1)
	LD	DE,(ARG2)
	JR	NC, FILL1
	LD	C,0			;FUELLBYTE 00 FESTLEGEN
FILL1:	LD	(HL),C
	PUSH	HL
	XOR	A
	EX	DE,HL
	SBC	HL,DE
	LD	B,H
	LD	C,L
	POP	HL
	LD	D,H
	LD	E,L
	INC	DE
	LDIR
	RET


;******************************
;* MEMSIZE                    *
;******************************

	DW	HEAD
	DB	"SIZE"
	NOP
	CALL	PRINT
	DB	"RAMTOP:"
	DB	0
	LD	HL,(MSIZE)
	CALL	OUTHL
	CALL	INHEX
        jr      c, loc_F68A
        ld      (MSIZE), hl
loc_F68A:
	call    PRINT
        db 	"CRTBGN:",0
        ld      hl, (CRTRAM)
        call    OUTHL
        call    INHEX
        ret     c
        ld      (CRTRAM), hl
        ld      d, h
        ld      e, l
        call    gpage
        ret

; -----------------------------
MEMSI: 	ld      a, (MSIZE+1)
	ld      b, a
        ld      a, (MSIZE)
        ret

;******************************
;* GO                         *
;******************************

        DW	HEAD
    	db "GO",0
        dec     de
        call    ASHEX
        jp      c, ERROR
        ld      bc, MAIN
        push    bc
        jp      (hl)

;******************************
;* HELP                       *
;******************************

	DW	HEAD
	DB	"HELP"
	NOP
	LD	HL,0
	LD	BC,0
	call    CRALF
HELP1:	CALL	PRINT
	DB	"   "
	DB	0
HELP2:	LD	A,L(HEAD)
	CPIR				;SUCHE NACH ED
	RET	NZ
	LD	A,H(HEAD)
	CP	A, (HL)			;FOLGT FF?
	JR	NZ, HELP2		;NEIN
	PUSH	HL
	PUSH	BC
	LD	B,16			;TEST,OB NACH SPAETESTENS
HELP3:	LD	A,(HL)			;16 ZEICHEN EIN NOP FOLGT
	INC	HL
	OR	A
	JR	Z, HELP4		;JA,AUSGABE
	DJNZ	HELP3
	POP	BC
	POP	HL
	JR	HELP2
HELP4:	POP	BC			;AUSGABE
	POP	HL
HELP5:	INC	HL
	DEC	BC
	LD	A,(HL)
	OR	A			;TEST ENDE
	JR	Z, HELP1
	CALL	COO
	JR	HELP5

;******************************
;* GERAETEROUTINEN            *
;******************************

IOBYTE: ld      a, (IOB)
        ret

; ----------------------------------
        dw	HEAD
	db 	"IOBYTE",0
        call    IOBYTE
        call    OUTH
        call    INHEX
        ret     c
        ld      c, l
IOSET:  push    af
        ld      a, c
        ld      (IOB), a
        pop     af
        ret

; ----------------------------------
; START OF FUNCTION CHUNK FOR RIX

RIX1:   in      a, KEYBD
        cp      1Ah
        ret     z
        in      a, CSIOA
        and     1
        jr      z, RIX1
        in      a, DSIOA
        ret

; ----------------------------------
; START OF FUNCTION CHUNK FOR COX

CPO0:   ld      a, c
        out     (DSIOA), a
CPO11:  in      a, (CSIOA)
        and     4
        jr      z, CPO11
        ret

; ----------------------------------
;KASSETTE INITIALISIEREN
CINIT:	LD	C,CSIOA
	LD	B,8
	LD	HL,CTAB
	OTIR
	LD	A,5
	OUT	CTC2, A
	LD	A,5
	OUT	CTC2, A
	RET

CTAB:	DB	4		;Register WR4
	DB	4
	DB	1		;Register WR1
	DB	40H
	DB	3		;Register WR3
	DB	0C1H
	DB	5		;Register WR5
	DB	0EAH

; ----------------------------------
;CONSOLSTATUSABFRAGE
CSTS:   in      a, KEYBC
        or      a
        jr      nz, loc_F758	;TASTE
        ld      (CSTSR), a
        ret
loc_F758:
	ld      a, (CSTSR)
        dec     a
        ret

CSTSR:  db 0

; ----------------------------------
;TASTATUREINGABE
CIX:    call    CSTS
        jr      z, CIX
        ld      a, 1
        ld      (CSTSR), a
        in      a, KEYBD
        ret

; ----------------------------------
; KASSETTENEINGABE
RIX:    ld      a, (IOB)
        and     0Ch
        jr      z, CIX
        cp      4
        jp      z, RIX1
        cp      0Ch
        jp      z, USERRI
        ld      a, 1Ah
        ret

; ----------------------------------
; START OF FUNCTION CHUNK FOR COX

LOX:    ld      a, (IOB)
        and     0C0h
        jp      z, COX
        cp      40h
        jp      z, POX
        cp      80h
        jp      z, PRINTER
        jp      USERLO

; ----------------------------------
CPO:    push    bc
        ld      c, a
        call    POX
        pop     bc
        ret

; ----------------------------------
; KASSETTE SCHREIBEN
POX:    ld      a, (IOB)
        and     30h
        jp      z, COX
        cp      10h
        jp      z, CPO0
        cp      20h
        jp      z, LOX
        jp      USERPO

; ----------------------------------
COO:    push    bc
        ld      c, a
        ld      (byte_F7BD), a
        call    COX
        ld      a, (byte_F7BD)
        pop     bc
        ret

byte_F7BD:
	db 0

; ----------------------------------
COX:    ld      a, (IOB)
        and     3
        jp      z, conout
        cp      1
        jp      z, POX
        cp      2
        jp      z, LOX
        jp      USERCO

;******************************
;listing 2.55
;******************************

	include grafik.asm
;conout	equ	$
;gpage	EQU	0f943h
;	ds	0f9f7h-$

;******************************
; Zeichensatz
;******************************

	include	chargen.asm

;******************************
;RAM BEREICH

FINA:	DB	8	dup (?)		;FILENAME REGISTER
FITY:	DB	2	dup (?)		;FILETYP REGISTER
ARG1:	DB	2	dup (?)		;HEX EINGABEN
ARG2:	DB	2 	dup (?)
ARG3:	DB	2 	dup (?)
DATA:	DB	16	dup (?)		;ZUSATZREGISTER (FILE-INFO
INTV:	DB	32	dup (?)		;INTERRUPT VEKTOREN
CRTRAM	Dw	CRTBG
CURXY	Dw	CRTBG
ESCSEQ	DB	1 	dup (?)
akku	DB	1 	dup (?)
IOB	DB	1 	dup (?)
PRINTER	jp	IORET
USERCO	jp	IORET
USERRI  jp	IORET
USERPO	jp	IORET
USERLO	jp	IORET
IORET	ret
TXTPT	DB	2 	dup (?)
TXTBU	DB	81 	dup (?)		;TEXTPUFFER
BULEN:	EQU	81			;PUFFERLAENGE
MSIZE:	EQU	$			;HOECHSTER FREIER SPEICHERPLATZ
;
STACK	EQU	0FF6Bh
HEAD:	EQU	0FFEDH			;SUCHCODE VOR KOMMANDO
CRTBG:	EQU	0C000H			;BILDSCHIRMADR.

IOBYT   EQU	84h			;Standard-IO-Byte

	dephase

	;EJEC
;******************************
;* VEREINBARUNGEN             *
;******************************

;PORTS:
ROMOF:	EQU	0			;ROM OFF
ROMON:	EQU	4			;ROM ON
KEYBD:	EQU	8			;TASTATURDATEN
KEYBC:	EQU	9			;TASTATURSTATUS 0FFH=GEDR./0=KEINE TASTE
video	equ	10h
;BEPOF:	EQU	8			;SIGNALTON AUS
;BEPON:	EQU	9			;AN
DP1A:	EQU	0CH			;12  PIO 1
CP1A:	EQU	0DH			;13
DP1B:	EQU	0EH			;14
CP1B:	EQU	0FH			;15
;DP2A:	EQU	10H			;16  STEUERPORT LBL
;CP2A:	EQU	11H			;17  BIT 0 STATUS,BIT 4 STARTIMPULS
;DP2B:	EQU	12H			;18 LBL DATEN
;CP2B:	EQU	13H			;19
CTCO:	EQU	14H			;20
CTC1:	EQU	15H			;21
CTC2:	EQU	16H			;22 KASSETTE
CTC3:	EQU	17H			;23
DSIOA:	EQU	18H			;24 KASSETTE
CSIOA:	EQU	19H			;25
DSIOB:	EQU	1AH			;26
CSIOB:	EQU	1BH			;27
;
CURL:	EQU	bs			;CURSOR LINKS
CURR:	EQU	15h			;RECHTS
CURD:	EQU	0AH			;RUNTER
CURU:	EQU	1AH			;HOCH
HOME:	EQU	01H			;
ESC:	EQU	1BH			;ESCAPE
bs	equ	08h
NL:	EQU	1EH			;NEW LINE
LF:	EQU	0AH			;LINE FEED
CR:	EQU	0DH			;RETURN
CLS:	EQU	0CH			;BILDSCHIRM LOESCHEN

SOH:	EQU	1			;START KOPF
GS:	EQU	1DH			;GRUPPENTRENNUNG
ETX:	EQU	03H			;END OF TEXT
EOT:	EQU	04H			;END OF TRANSMISSION
STX:	EQU	02H			;START OF TEXT
ERA:	EQU	06H			;EINGABEZEILE LOESCHEN
EOF:	EQU	ETX			;END OF FILE

MEMB:	EQU	8			;BYTES/ZEILE (MEMORY)
MEML:	EQU	24			;ANZAHL ZEILEN (MEM)
CHPL:	EQU	32			;ZEICHEN/ZEILE (CRT)
;

	END
